package org.stm.survey.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.stm.survey.entity.SurveyUserData;
import org.stm.survey.service.ISurveyUserDataService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;

 /**
 * @Description: 调查数据
 * @Author: jeecg-boot
 * @Date:   2023-11-14
 * @Version: V1.0
 */
@Api(tags="调查数据")
@RestController
@RequestMapping("/survey/surveyUserData")
@Slf4j
public class SurveyUserDataController extends JeecgController<SurveyUserData, ISurveyUserDataService> {
	@Autowired
	private ISurveyUserDataService surveyUserDataService;
	
	/**
	 * 分页列表查询
	 *
	 * @param surveyUserData
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调查数据-分页列表查询")
	@ApiOperation(value="调查数据-分页列表查询", notes="调查数据-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<SurveyUserData>> queryPageList(SurveyUserData surveyUserData,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<SurveyUserData> queryWrapper = QueryGenerator.initQueryWrapper(surveyUserData, req.getParameterMap());
		Page<SurveyUserData> page = new Page<SurveyUserData>(pageNo, pageSize);
		IPage<SurveyUserData> pageList = surveyUserDataService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	 @GetMapping(value = "/userDataList")
	 public Result<List<SurveyUserData>> queryUserDataList(SurveyUserData surveyUserData,
														HttpServletRequest req) {
		 QueryWrapper<SurveyUserData> queryWrapper = QueryGenerator.initQueryWrapper(surveyUserData, req.getParameterMap());
		 List<SurveyUserData> list = surveyUserDataService.list(queryWrapper);
		 return Result.OK(list);
	 }


	
	/**
	 *   添加
	 *
	 * @param surveyUserData
	 * @return
	 */
	@AutoLog(value = "调查数据-添加")
	@ApiOperation(value="调查数据-添加", notes="调查数据-添加")
	@RequiresPermissions("survey:survey_user_data:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody SurveyUserData surveyUserData) {
		surveyUserDataService.save(surveyUserData);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param surveyUserData
	 * @return
	 */
	@AutoLog(value = "调查数据-编辑")
	@ApiOperation(value="调查数据-编辑", notes="调查数据-编辑")
	@RequiresPermissions("survey:survey_user_data:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody SurveyUserData surveyUserData) {
		surveyUserDataService.updateById(surveyUserData);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查数据-通过id删除")
	@ApiOperation(value="调查数据-通过id删除", notes="调查数据-通过id删除")
	@RequiresPermissions("survey:survey_user_data:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		surveyUserDataService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查数据-批量删除")
	@ApiOperation(value="调查数据-批量删除", notes="调查数据-批量删除")
	@RequiresPermissions("survey:survey_user_data:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.surveyUserDataService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查数据-通过id查询")
	@ApiOperation(value="调查数据-通过id查询", notes="调查数据-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<SurveyUserData> queryById(@RequestParam(name="id",required=true) String id) {
		SurveyUserData surveyUserData = surveyUserDataService.getById(id);
		if(surveyUserData==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(surveyUserData);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param surveyUserData
    */
    @RequiresPermissions("survey:survey_user_data:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, SurveyUserData surveyUserData) {
        return super.exportXls(request, surveyUserData, SurveyUserData.class, "调查数据");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("survey:survey_user_data:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, SurveyUserData.class);
    }

}
